/*
-----------------------------------------------------------------------------
-      ATMEL Microcontroller Software Support  -   ROUSSET -
-----------------------------------------------------------------------------
 The software is delivered "AS IS" without warranty or condition of any
 kind, either express, implied or statutory. This includes without
 limitation any warranty or condition with respect to merchantability or
 fitness for any particular purpose, or against the infringements of
 intellectual property rights of others.
-----------------------------------------------------------------------------
- File Name            : arm.inc
- Object               : ARM Core Definition File.
- Translator           : ARM Software Development Toolkit V2.11a
-
- 1.0 10/03/98 JCZ     : Creation
- 2.0 21/10/98 JCZ     : Clean up.
-----------------------------------------------------------------------------
*/
/*
-------------------------------
- ARM Core Mode and Status Bits
-------------------------------
*/
.equ ARM_MODE_USER,0x10
.equ ARM_MODE_FIQ,0x11
.equ ARM_MODE_IRQ,0x12
.equ ARM_MODE_SVC,0x13
.equ ARM_MODE_ABORT,0x17
.equ ARM_MODE_UNDEF,0x1B
.equ ARM_MODE_SYS,0x1F

.equ I_BIT,0x80
.equ F_BIT,0x40
.equ T_BIT,0x20


