/*
-----------------------------------------------------------------------------
-      ATMEL Microcontroller Software Support  -   ROUSSET -
-----------------------------------------------------------------------------
 The software is delivered "AS IS" without warranty or condition of any
 kind, either express, implied or statutory. This includes without
 limitation any warranty or condition with respect to merchantability or
 fitness for any particular purpose, or against the infringements of
 intellectual property rights of others.
-----------------------------------------------------------------------------
- File Name            : ps.h
- Object               : Power Saving Definition File
- Translator           : ARM Software Development Toolkit V2.11a
-
- 1.0 10/03/98 JCZ     : Creation
- 2.0 21/10/98 JCZ     : Clean up.
-----------------------------------------------------------------------------
*/
/*
---------------------------------------------------
- Power Management Controller Structure Definition
---------------------------------------------------
*/

.equ	PS_CR,0x00       ; Control Register

/*
-------------------------------------------------------
- Power Management Controller Register Bits Definition
-------------------------------------------------------
*/

.equ	ARM7DIS,(1<<0)

/*
--------------------------------
- Device Dependancies Definition
--------------------------------
*/

    .IFDEF AT91M40400
.equ PS_BASE,0xFFFF4000
    .ENDIF


